//
// $Id: global.cc,v 1.1 1999/08/05 21:08:11 voeckler Exp $
//
// Author:  Jens-S. Vckler <voeckler@rvs.uni-hannover.de>
//
// File:    global.cc
//          Thu Aug 05 1999
//
// (c) 1999 Lehrgebiet Rechnernetze und Verteilte Systeme
//          Universitt Hannover, Germany
//
// Permission to use, copy, modify, distribute, and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission
// notice appear in all copies of the software and related documentation,
// and (ii) the names of the Lehrgebiet Rechnernetze und Verteilte
// Systeme and the University of Hannover may not be used in any
// advertising or publicity relating to the software without the
// specific, prior written permission of Lehrgebiet Rechnernetze und
// Verteilte Systeme and the University of Hannover.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//
// IN NO EVENT SHALL THE LEHRGEBIET RECHNERNETZE UND VERTEILTE SYSTEME OR
// THE UNIVERSITY OF HANNOVER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
// INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
// ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
// SOFTWARE.
//
// $Log: global.cc,v $
// Revision 1.1  1999/08/05 21:08:11  voeckler
// Initial revision
//
//
#if defined(__GNUC__) || defined(__GNUG__)
#pragma implementation
#endif

#include <stdlib.h>
#include <string.h>
#include "global.hh"

static const char* RCS_ID =
"$Id: global.cc,v 1.1 1999/08/05 21:08:11 voeckler Exp $";

Global globals;

Global::Global()
  :noIdent(false),clientFQDN(true),
   warnUnknownMethod(false),
   warnUnknownHier(false),
   warnUnknownStatus(false),
   warnUnknownScheme(false),
   warnUnknownTLD(false),
   debugClass(0u),debugLevel(0u),
   warnCrashInterval(C_U32(1800)),
   peakInterval(C_U32(3600)),
   dnsPositiveTTL(C_U32(18144000)),
   dnsNegativeTTL(C_U32(604800)),
   irrPositiveTTL(C_U32(18144000)),
   irrNegativeTTL(C_U32(604800)),
   dnsCacheFile(strdup("/var/tmp/dns")),
   irrCacheFile(strdup("/var/tmp/irr")),
   irrServer(strdup("whois.ripe.net")),
   startTime(C_U32(0)),stopTime(C_U32(0))
{ }

Global::~Global()
{
  free((void*) dnsCacheFile );
  free((void*) irrCacheFile );
  if ( irrServer ) free((void*) irrServer );
}
