//
// $Id: global.hh,v 1.2 1999/08/06 08:44:33 voeckler Exp $
//
// Author:  Jens-S. Vckler <voeckler@rvs.uni-hannover.de>
//
// File:    global.hh
//          Thu Aug 05 1999
//
// (c) 1999 Lehrgebiet Rechnernetze und Verteilte Systeme
//          Universitt Hannover, Germany
//
// Permission to use, copy, modify, distribute, and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission
// notice appear in all copies of the software and related documentation,
// and (ii) the names of the Lehrgebiet Rechnernetze und Verteilte
// Systeme and the University of Hannover may not be used in any
// advertising or publicity relating to the software without the
// specific, prior written permission of Lehrgebiet Rechnernetze und
// Verteilte Systeme and the University of Hannover.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//
// IN NO EVENT SHALL THE LEHRGEBIET RECHNERNETZE UND VERTEILTE SYSTEME OR
// THE UNIVERSITY OF HANNOVER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
// INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
// ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
// SOFTWARE.
//
// $Log: global.hh,v $
// Revision 1.2  1999/08/06 08:44:33  voeckler
// added debugging to DNS using the debug level and debug class from global.
//
// Revision 1.1  1999/08/05 21:08:11  voeckler
// Initial revision
//
//
#ifndef _GLOBAL_HH
#define _GLOBAL_HH

#if defined(__GNUC__) || defined(__GNUG__)
#pragma implementation
#endif

#include "typedefs.h"

class Global {
public:
  enum {
    D_DNS = 0x0001,
    D_IRR = 0x0002,
    D_ALL = 0xFFFF
  };

  Global();
  ~Global();

  bool            noIdent;
  bool		  clientFQDN;
  bool	          warnUnknownMethod;
  bool	          warnUnknownHier;
  bool	          warnUnknownStatus;
  bool	          warnUnknownScheme;
  bool	          warnUnknownTLD;

  unsigned short  debugClass;
  unsigned short  debugLevel;
  MyUInt32	  warnCrashInterval;
  MyUInt32 	  peakInterval;
  MyUInt32	  dnsPositiveTTL;
  MyUInt32	  dnsNegativeTTL;
  MyUInt32	  irrPositiveTTL;
  MyUInt32	  irrNegativeTTL;
  const char*     dnsCacheFile;
  const char*     irrCacheFile;
  const char*     irrServer;

  MyUInt32	  startTime;
  MyUInt32	  stopTime;
};

extern Global globals;

#endif // _GLOBAL_HH
