//
// $Id: irr.hh,v 1.1 1999/08/05 21:06:01 voeckler Exp $
//
// Author:  Jens-S. Vckler <voeckler@rvs.uni-hannover.de>
//
// File:    irr.hh
//          Thu Aug 05 1999
//
// (c) 1999 Lehrgebiet Rechnernetze und Verteilte Systeme
//          Universitt Hannover, Germany
//
// Permission to use, copy, modify, distribute, and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission
// notice appear in all copies of the software and related documentation,
// and (ii) the names of the Lehrgebiet Rechnernetze und Verteilte
// Systeme and the University of Hannover may not be used in any
// advertising or publicity relating to the software without the
// specific, prior written permission of Lehrgebiet Rechnernetze und
// Verteilte Systeme and the University of Hannover.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//
// IN NO EVENT SHALL THE LEHRGEBIET RECHNERNETZE UND VERTEILTE SYSTEME OR
// THE UNIVERSITY OF HANNOVER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
// INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
// ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
// SOFTWARE.
//
// $Log: irr.hh,v $
// Revision 1.1  1999/08/05 21:06:01  voeckler
// Initial revision
//
//
#ifndef _IRR_HH
#define _IRR_HH

#if defined(__GNUC__) || defined(__GNUG__)
#pragma interface
#endif

#include <ndbm.h>
#include "typedefs.h"
#include "cache.hh"
#include "dns.hh"
#include "string.hh"

class IRRCache : public BaseCache {
public:
  IRRCache( const char* cacheFile = "/var/tmp/irr",
	    const char* whoisServer = "whois.ra.net",
	    MyUInt32 posTTL = 3600 * 24 * 30,
	    MyUInt32 negTTL = 3600 * 24 * 7 );
  ~IRRCache();

  int getOriginByHost( MyUInt32 address );
  // returns: >0: origin AS number
  //           0: unresolved AS

  int getOriginByHost( DNSCache& dns, const char* hostname );
  // returns: >0: origin AS number
  //           0: unresolved AS
  //          -1: unresolved DNS

  String getDescriptionByOrigin( MyUInt32 address );
  String getDescriptionByOrigin( const char* address );

protected:
  DBM*        db;
  MyUInt32    server;
  int	      sockfd;

private:
  // disallow
  IRRCache( const IRRCache& );
  IRRCache& operator=( const IRRCache& );
};

#endif // _IRR_HH
