//
// $Id: output.hh,v 1.1 1999/08/05 21:17:11 voeckler Exp $
//
// Author:  Jens-S. Vckler <voeckler@rvs.uni-hannover.de>
//
// File:    output.hh
//          Thu Aug 05 1999
//
// (c) 1999 Lehrgebiet Rechnernetze und Verteilte Systeme
//          Universitt Hannover, Germany
//
// Permission to use, copy, modify, distribute, and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that (i) the above copyright notices and this permission
// notice appear in all copies of the software and related documentation,
// and (ii) the names of the Lehrgebiet Rechnernetze und Verteilte
// Systeme and the University of Hannover may not be used in any
// advertising or publicity relating to the software without the
// specific, prior written permission of Lehrgebiet Rechnernetze und
// Verteilte Systeme and the University of Hannover.
//
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
//
// IN NO EVENT SHALL THE LEHRGEBIET RECHNERNETZE UND VERTEILTE SYSTEME OR
// THE UNIVERSITY OF HANNOVER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
// INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT
// ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY,
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
// SOFTWARE.
//
// $Log: output.hh,v $
// Revision 1.1  1999/08/05 21:17:11  voeckler
// Initial revision
//
//
#ifndef _OUTPUT_HH
#define _OUTPUT_HH

#if defined(__GNUC__) || defined(__GNUG__)
#pragma interface
#endif

#include "typedefs.h"
#include "counter.hh"
#include "counters.hh"
#include "dns.hh"
#include "irr.hh"

enum Selector {
  // currently unused, later for selection of output
  BY_NONE=0,
  BY_REQS=1,
  BY_SIZE=2,
  BY_BOTH=3
};

void showTitle();
void showOverview( const Counters& counters );
void showMethods( const Counters& counters );
void showSchemes( const Counters& counters );
void showTLD( const Counters& counters, const size_t number = 0 );
void showSLD( const Counters& counters, const size_t number = 0 );
void showHierarchy( DNSCache& dns, const Counters& counters );
void showMediatypes( const Counters& counters );
void showPorts( const Counters& counters );
void showUDPClients( DNSCache& dns, const Counters& counters, 
		     const size_t number = 0 );
void showTCPClients( DNSCache& dns, const Counters& counters, 
		     const size_t number = 0 );
void showASN( DNSCache& dns, IRRCache& irr,
	      const Counters& counters, const size_t number = 0 );
void showPeaks( const Counters& counters );
void showStats( DNSCache& dns, IRRCache* irr,
		double looptime, double startup, MyUInt32 lineno );

#endif // _OUTPUT_HH
